﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Parallel
{
	internal class Executor<T, TResult>
	{
		private readonly IParallelEnumerable<T> data;
		private readonly Func<IParallelEnumerable<T>, IParallelEnumerable<TResult>> func;
		IParallelEnumerable<TResult> returnValue;

		public Executor(IParallelEnumerable<T> data, Func<IParallelEnumerable<T>, IParallelEnumerable<TResult>> func)
		{
			this.data = data;
			this.func = func;
		}

		public void Execute()
		{
			returnValue = func(data);
		}

		public IParallelEnumerable<TResult> Value
		{
			get { return returnValue; }
		}

	}
}
