﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Parallel
{
	internal class ParallelContainer<T> : IParallelEnumerable<T>
	{
		private readonly IList<T> list;

		public ParallelContainer(IEnumerable<T> enumerable)
		{
			list = enumerable.ToList();
		}

		public ParallelContainer(IList<T> list)
		{
			this.list = list;
		}

		public ParallelContainer()
		{
			this.list = new List<T>();
		}


		#region IEnumerable<T> Members

		public IEnumerator<T> GetEnumerator()
		{
			return list.GetEnumerator();
		}

		#endregion

		#region IEnumerable Members

		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
		{
			throw new NotImplementedException();
		}

		#endregion
	}
}
