﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Diagnostics;
using System.Reflection;
using Parallel;

namespace Parallel
{
	class Program
	{
		
		static void Main(string[] args)
		{
			var upto = 10000000;
			Stopwatch watch = Stopwatch.StartNew();

			Console.WriteLine("Sequential Primes Count {0}, Time Elapsed {1}", Sequential(upto), watch.Elapsed);
			
			watch.Reset();
			watch.Start();

			Console.WriteLine("Parallel Primes Count {0}, Time Elapsed {1}", Parallel(upto), watch.Elapsed);
		}

		private static int Parallel(int n)
		{
			var items = from value in 1.To(n).ToParallel()
						where value.IsPrime()
						select new { Value = value, Binary = value.ToBinary() };

			var primesCount = items.Count();
			return primesCount;
		}

		private static int Sequential(int n)
		{
			var items = from value in 1.To(n)
						where value.IsPrime()
						select new { Value = value, Binary = value.ToBinary() };

			var primesCount = items.Count();
			return primesCount;
		}
	}
}
